#include "Condition.h"

void condition_wait(Condition *condition, Lock *lock) {
  int err;

  parallel_suspend();

  if ((err = pthread_cond_wait(condition, lock)) != 0) {
    throw("condition_wait() failed with error %d", err);
  }

  parallel_resume();
}

void condition_signal(Condition *condition) {
  int err;

  if ((err = pthread_cond_broadcast(condition)) != 0) {
    throw("condition_signal() failed with error %d", err);
  }
}

void condition_initialize(Condition *condition) {
  int err;

  if ((err = pthread_cond_init(condition, null)) != 0) {
    throw("condition_initialize() failed with error %d", err);
  }
}
