/* Simple static library wrapper around pthread conditions.
 */
#ifndef CONDITION_H
#define CONDITION_H

#ifdef __cplusplus
extern "C" {
#endif

#include "jpc.h"
#include <pthread.h>

#define CONDITION_INITIALIZER PTHREAD_COND_INITIALIZER

typedef pthread_cond_t Condition;

/* Wait on a condition, locked by a given lock.
 */
void condition_wait(Condition *condition, Lock *lock);

/* Signal a condition. Actually does a broadcast.
 */
void condition_signal(Condition *condition);

/* Initialize a condition. This is only needed if it cannot be done using the
 * initializer above.
 */
void condition_initialize(Condition *condition);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* _H */
