#include "Decider.h"

#define P_VALUE_ 0.05

void decider_new(Decider **p_this) {
  Decider *this;

  this = newo(p_this);
  lock_initialize(&this->lock);
}

void decider_delete(Decider **p_this) {
  Decider *this;

  if ((this = *p_this) == null) {
    return;
  }

  if (this->iteration != 2) {
    throw("Destructor called before two iterations have been completed");
  }

  deleteo(p_this);
}

double decider_get_p_value(Decider *this, ulong num_new_decisions) {
  double p_value;

  if (num_new_decisions == 0) {
    throw("Number of new decisions cannnot be zero");
  }

  switch (this->iteration) {
    case 0:
      lock(&this->lock);
      this->numDecisions += num_new_decisions;
      p_value = P_VALUE_ / this->numDecisions;
      unlock(&this->lock);

      return p_value;

    case 1:
      return this->pValue;

    default:
      throw("Impossible");
  }

  return DBL_NAN;
}

void decider_end_iteration(Decider *this) {
  lock(&this->lock);

  switch (this->iteration) {
    case 0:
      this->pValue = P_VALUE_ / this->numDecisions;
      break;
    case 1:
      break;
    default:
      throw("Cannot end more than two iterations");
      break;
  }

  this->iteration++;
  unlock(&this->lock);
}

void decider_end_iterations(Decider *this) {
  lock(&this->lock);
  this->pValue = P_VALUE_ / this->numDecisions;
  this->iteration = 2;
  unlock(&this->lock);
}
