#include "KeyFrequency.h"

static void merge_(KeyValuePair *acc, KeyValuePair *add, KeyValueInfo *info);


void key_frequency_info_new(
    KeyValueInfo **p_this,
    ulong num_keys,
    ulong *max_keys,
    ulong max_frequency) {
  KeyValueInfo *this;

  max_frequency--;
  key_value_info_new(p_this, num_keys, max_keys, 1, &max_frequency);
  this = *p_this;
  this->merge = merge_;
}

ulong key_frequency_pair_get_frequency(
    KeyValuePair *pair,
    KeyValueInfo *info) {
  return key_value_pair_get_value(pair, info, 0) + 1;
}

void key_frequency_pair_set_frequency(
    KeyValuePair *pair,
    KeyValueInfo *info,
    ulong frequency) {
  if (frequency == 0) {
    throw("Invalid zero frequency");
  }

  key_value_pair_set_value(pair, info, 0, frequency - 1);
}


static void merge_(KeyValuePair *acc, KeyValuePair *add, KeyValueInfo *info) {
  ulong f1;
  ulong f2;

  f1 = key_frequency_pair_get_frequency(acc, info);
  f2 = key_frequency_pair_get_frequency(add, info);
  key_frequency_pair_set_frequency(acc, info, f1 + f2);
}
