/* Special case of key-value pairs when there is a single value field that is
 * the nonzero frequency of the pair. These methods handle the storage of one
 * less than the frequency, since it can never be zero, which can save storage
 * and, in some cases, speed up access.
 */
#ifndef KEY_FREQUENCY_H
#define KEY_FREQUENCY_H

#ifdef __cplusplus
extern "C" {
#endif

#include "KeyValueArray.h"
#include "KeyValueInfo.h"

/* Constructor.
 */
void key_frequency_info_new(
    KeyValueInfo **p_this,
    ulong num_keys,
    ulong *max_keys,
    ulong max_frequency);

/* Get the frequency.
 */
ulong key_frequency_pair_get_frequency(KeyValuePair *pair, KeyValueInfo *info);

/* Set the frequency.
 */
void key_frequency_pair_set_frequency(
    KeyValuePair *pair,
    KeyValueInfo *info,
    ulong frequency);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* _H */
