#include "KeyValueByte.h"

void key_value_byte_new(
    KeyValueByte **p_this,
    ulong value_mask,
    sbyte shift,
    byte byte_mask) {
  KeyValueByte *this;

  this = newo(p_this);

  this->valueMask = value_mask;
  this->shift = shift;
  this->readByteMask = byte_mask;
  this->writeByteMask = ~byte_mask;
}

void key_value_byte_new_copy(KeyValueByte **p_this, KeyValueByte *other) {
  key_value_byte_new(
      p_this,
      other->valueMask,
      other->shift,
      other->readByteMask);
}

void key_value_byte_new_load(KeyValueByte **p_this, File *f) {
  KeyValueByte *this;

  this = newo(p_this);

  load_label("[KeyValueByte]", f);
  load_value(this->readByteMask, f);
  load_value(this->writeByteMask, f);
  load_value(this->shift, f);
  load_value(this->valueMask, f);
  load_label("[/KeyValueByte]", f);
}

void key_value_byte_delete(KeyValueByte **p_this) {
  if (*p_this == null) {
    return;
  }

  deleteo(p_this);
}

void key_value_byte_print(KeyValueByte *this, Printer *p) {
  sprint(p, "KeyValueByte");
  rprint(p, "Value mask: 0x%lx", this->valueMask);
  rprint(p, "Shift: %d", this->shift);
  rprint(p, "Read byte mask: 0x%02x", this->readByteMask);
  rprint(p, "Write byte mask: 0x%02x", this->writeByteMask);
  fprint(p);
}

void key_value_byte_save(KeyValueByte *this, File *f) {
  save_label("[KeyValueByte]", f);
  save_value(this->readByteMask, f);
  save_value(this->writeByteMask, f);
  save_value(this->shift, f);
  save_value(this->valueMask, f);
  save_label("[/KeyValueByte]", f);
}

bool key_value_byte_equals(KeyValueByte *this, KeyValueByte *other) {
  return other->valueMask == this->valueMask
    && other->shift == this->shift
    && other->readByteMask == this->readByteMask;
}
