/* Static library for parsing a time budget string from the command line, and
 * printing such a parsed time budget in a standard form.
 */
#ifndef TIME_BUDGET_H
#define TIME_BUDGET_H

#ifdef __cplusplus
extern "C" {
#endif

#include "jpc.h"

#define TIME_BUDGET_FORMATS \
  "'<H>:<MM>:<SS>', '<M>:<SS>', '<H>h', '<M>m', '<S>s'"

typedef struct {
  byte hours;
  byte minutes;
  byte seconds;
  ulong totalSeconds;
  ulong us;
} TimeBudget;

/* Parse a time budget string, returning the above structure of values.
 */
TimeBudget time_budget_parse(char *budget);

/* Populate a time budget from the number of microseconds.
 */
TimeBudget time_budget_from_us(long us);

/* Create a string that represents a time budget.
 */
void string_new_time_budget(char **p_this, TimeBudget tb);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* _H */
