#include "BearAssemblyTestDeath.h"

START_DEATH

TEST(BearAssembly, NewParent) {
  BearAssembly *_1 = null;
  BearAssembly *_2 = null;

  bear_assembly_new_empty(&_1);
  EXPECT_DEATH(
      bear_assembly_new_parent(&_2, _1),
      "Cannot create the parent of an empty assembly");
  bear_assembly_delete(&_2);
  bear_assembly_delete(&_1);
}

TEST(BearAssembly, NewMelt) {
  BearPart *_p = null;
  BearAssembly *_1 = null;
  BearAssembly *_2 = null;

  /* Cannot melt anything to an empty assembly.
   */
  bear_assembly_new_empty(&_1);
  bear_part_new_elementary(&_p, 27);
  EXPECT_DEATH(
      bear_assembly_new_melt(&_2, _1, _p),
      "Attachment cannot be melted to the base");
  bear_part_delete(&_p);
  bear_assembly_delete(&_2);
  bear_assembly_delete(&_1);
}

TEST(BearAssembly, FirstPart) {
  BearAssembly *_ = null;

  bear_assembly_new_empty(&_);
  EXPECT_DEATH(
      bear_assembly_first_part(_),
      "Cannot get the first part of an empty assembly");
  bear_assembly_delete(&_);
}

TEST(BearAssembly, LastPart) {
  BearAssembly *_ = null;

  bear_assembly_new_empty(&_);
  EXPECT_DEATH(
      bear_assembly_last_part(_),
      "Cannot get the last part of an empty assembly");
  bear_assembly_delete(&_);
}

FINISH_DEATH
