#include "ConditionTest.h"

typedef struct {
  bool *done;
  Condition *condition;
  Lock *lock;
} Pass_;

static void do_(Parallel *par);


START

TEST(Condition, Basic) {
  bool done;
  Lock lock = LOCK_INITIALIZER;
  Condition condition = CONDITION_INITIALIZER;
  Pass_ pass;

  pass.lock = &lock;
  pass.condition = &condition;
  pass.done = &done;
  parallel_for_all(3, do_, &pass);
}

FINISH


static void do_(Parallel *par) {
  Pass_ *pass;

  pass = par->x;

  if (par->t > 0) {
    lock(pass->lock);

    while (!*pass->done) {
      condition_wait(pass->condition, pass->lock);
    }

    unlock(pass->lock);
  } else {
    sleep(1);

    lock(pass->lock);
    *pass->done = true;
    condition_signal(pass->condition);
    unlock(pass->lock);
  }
}
