#include "DictionaryTestDeath.h"

static void new_(Dictionary **p_this);


START_DEATH

TEST(Dictionary, New) {
  Dictionary *_d = null;

  EXPECT_DEATH(
      dictionary_new(&_d, null, null),
      "Destructor cannot be null");
}

TEST(Dictionary, Donate) {
  Dictionary *_d = null;

  new_(&_d);
  dictionary_finalize(_d);
  EXPECT_DEATH(
      dictionary_donate(_d, null, null),
      "Cannot donate to a finalized dictionary");
  dictionary_delete(&_d);
}

TEST(Dictionary, Finalize) {
  Dictionary *_d = null;

  new_(&_d);
  dictionary_finalize(_d);
  EXPECT_DEATH(
      dictionary_finalize(_d),
      "Cannot re-finalize a finalized dictionary");
  dictionary_delete(&_d);
}

TEST(Dictionary, Reopen) {
  Dictionary *_d = null;

  new_(&_d);
  EXPECT_DEATH(
      dictionary_reopen(_d),
      "Cannot reopen a dictionary until it is finalized");
  dictionary_delete(&_d);
}

TEST(Dictionary, Find) {
  Dictionary *_d = null;

  new_(&_d);
  EXPECT_DEATH(
      dictionary_find(_d, ""),
      "Cannot find in a dictionary until it is finalized");
  dictionary_delete(&_d);
}

TEST(Dictionary, Cardinality) {
  Dictionary *_d = null;

  new_(&_d);
  EXPECT_DEATH(
      dictionary_cardinality(_d),
      "Cannot get cardinality of a dictionary until it is finalized");
  dictionary_delete(&_d);
}

TEST(Dictionary, PairsNew) {
  DictionaryPairs *_dp = null;
  Dictionary *_d = null;

  new_(&_d);
  EXPECT_DEATH(
      dictionary_pairs_new(&_dp, _d, false),
      "Cannot get pairs from a dictionary until it is finalized");
  dictionary_delete(&_d);
}

FINISH_DEATH


static void new_(Dictionary **p_this) {
  dictionary_new(p_this, string_delete, string_print);
}
