#include "HeapTestDeath.h"

static void ulong_print_(HeapObjectPrintInfo *hopi, Printer *p);


START_DEATH

TEST(Heap, Comprehensive) {
  ulong max;
  ulong u;
  Heap *_ = null;

  max = ULONG_MAX;

  heap_new(&_, &max, ulong_compare, ulong_print_, null);
  EXPECT_DEATH(heap_get_min(_), "Cannot get minimum from an empty heap");
  EXPECT_DEATH(
      heap_extract_min(_, &u),
      "Cannot get minimum from an empty heap");
  u = 1;
  heap_add(_, &u);
  heap_add(_, &u);
  EXPECT_DEATH(heap_get_min(_), "Cannot get minimum before heap is heapified");
  EXPECT_DEATH(
      heap_extract_min(_, &u),
      "Cannot extract minimum before heap is heapified");
  heap_delete(&_);
}

FINISH_DEATH


static void ulong_print_(HeapObjectPrintInfo *hopi, Printer *p) {
  ulong *this;

  this = hopi->this;

  rprint(p, "%lu", *this);
}
