#include "KeyValueFieldTest.h"

static void test_(ulong *bit_offset,
    ulong max_value,
    byte expected_bit_width,
    byte expected_num_bytes,
    ulong expected_first_offset,
    KeyValueByte ***expected_bytes);


START

TEST(KeyValueField, Comprehensive) {
  ulong bit_offset;
  KeyValueByte **_bytes = null;

  new(&_bytes, 9);

  bit_offset = 0;

  CALL(test_(&bit_offset, 0, 0, 0, 0, &_bytes));

  key_value_byte_new(&_bytes[0], 0x1, -7, 0x80);
  CALL(test_(&bit_offset, 1, 1, 1, 0, &_bytes));

  key_value_byte_new(&_bytes[0], 0x3, -5, 0x60);
  CALL(test_(&bit_offset, 2, 2, 1, 0, &_bytes));

  key_value_byte_new(&_bytes[0], 0x3, -3, 0x18);
  CALL(test_(&bit_offset, 3, 2, 1, 0, &_bytes));

  key_value_byte_new(&_bytes[0], 0x7, 0, 0x07);
  CALL(test_(&bit_offset, 4, 3, 1, 0, &_bytes));

  key_value_byte_new(&_bytes[0], 0x7, -5, 0xe0);
  CALL(test_(&bit_offset, 7, 3, 1, 1, &_bytes));

  key_value_byte_new(&_bytes[0], 0xf, -1, 0x1e);
  CALL(test_(&bit_offset, 8, 4, 1, 1, &_bytes));

  key_value_byte_new(&_bytes[0], 0x8, 3, 0x01);
  key_value_byte_new(&_bytes[1], 0x7, -5, 0xe0);
  CALL(test_(&bit_offset, 0xf, 4, 2, 1, &_bytes));

  key_value_byte_new(&_bytes[0], 0x1f, 0, 0x1f);
  CALL(test_(&bit_offset, 0x10, 5, 1, 2, &_bytes));

  key_value_byte_new(&_bytes[0], 0x1f, -3, 0xf8);
  CALL(test_(&bit_offset, 0x1f, 5, 1, 3, &_bytes));

  key_value_byte_new(&_bytes[0], 0x38, 3, 0x07);
  key_value_byte_new(&_bytes[1], 0x07, -5, 0xe0);
  CALL(test_(&bit_offset, 0x20, 6, 2, 3, &_bytes));

  key_value_byte_new(&_bytes[0], 0x7c, 2, 0x1f);
  key_value_byte_new(&_bytes[1], 0x03, -6, 0xc0);
  CALL(test_(&bit_offset, 0x40, 7, 2, 4, &_bytes));

  key_value_byte_new(&_bytes[0], 0xfc, 2, 0x3f);
  key_value_byte_new(&_bytes[1], 0x03, -6, 0xc0);
  CALL(test_(&bit_offset, 0x80, 8, 2, 5, &_bytes));

  key_value_byte_new(&_bytes[0], 0x1f8, 3, 0x3f);
  key_value_byte_new(&_bytes[1], 0x007, -5, 0xe0);
  CALL(test_(&bit_offset, 0x100, 9, 2, 6, &_bytes));

  key_value_byte_new(&_bytes[0], 0x3e0, 5, 0x1f);
  key_value_byte_new(&_bytes[1], 0x01f, -3, 0xf8);
  CALL(test_(&bit_offset, 0x200, 10, 2, 7, &_bytes));

  key_value_byte_new(&_bytes[0], 0xe00, 9, 0x07);
  key_value_byte_new(&_bytes[1], 0x1fe, 1, 0xff);
  key_value_byte_new(&_bytes[2], 0x001, -7, 0x80);
  CALL(test_(&bit_offset, 0xfff, 12, 3, 8, &_bytes));

  key_value_byte_new(&_bytes[0], 0xfe00, 9, 0x7f);
  key_value_byte_new(&_bytes[1], 0x1fe, 1, 0xff);
  key_value_byte_new(&_bytes[2], 0x001, -7, 0x80);
  CALL(test_(&bit_offset, 0xffff, 16, 3, 10, &_bytes));

  key_value_byte_new(&_bytes[0], 0x7f000, 12, 0x7f);
  key_value_byte_new(&_bytes[1], 0x00ff0, 4, 0xff);
  key_value_byte_new(&_bytes[2], 0x0000f, -4, 0xf0);
  CALL(test_(&bit_offset, 0x7ffff, 19, 3, 12, &_bytes));

  key_value_byte_new(&_bytes[0], 0x1e00000, 21, 0x0f);
  key_value_byte_new(&_bytes[1], 0x01fe000, 13, 0xff);
  key_value_byte_new(&_bytes[2], 0x0001fe0, 5, 0xff);
  key_value_byte_new(&_bytes[3], 0x000001f, -3, 0xf8);
  CALL(test_(&bit_offset, 0x1ffffff, 25, 4, 14, &_bytes));

  key_value_byte_new(&_bytes[0], 0x38000000, 27, 0x07);
  key_value_byte_new(&_bytes[1], 0x07f80000, 19, 0xff);
  key_value_byte_new(&_bytes[2], 0x0007f800, 11, 0xff);
  key_value_byte_new(&_bytes[3], 0x000007f8, 3, 0xff);
  key_value_byte_new(&_bytes[4], 0x00000007, -5, 0xe0);
  CALL(test_(&bit_offset, 0x3fffffff, 30, 5, 17, &_bytes));

  key_value_byte_new(&_bytes[0], 0xf80000000, 31, 0x1f);
  key_value_byte_new(&_bytes[1], 0x07f800000, 23, 0xff);
  key_value_byte_new(&_bytes[2], 0x0007f8000, 15, 0xff);
  key_value_byte_new(&_bytes[3], 0x000007f80, 7, 0xff);
  key_value_byte_new(&_bytes[4], 0x00000007f, -1, 0xfe);
  CALL(test_(&bit_offset, 0xfffffffff, 36, 5, 21, &_bytes));

  key_value_byte_new(&_bytes[0], 0x400000000000, 46, 0x01);
  key_value_byte_new(&_bytes[1], 0x3fc000000000, 38, 0xff);
  key_value_byte_new(&_bytes[2], 0x003fc0000000, 30, 0xff);
  key_value_byte_new(&_bytes[3], 0x00003fc00000, 22, 0xff);
  key_value_byte_new(&_bytes[4], 0x0000003fc000, 14, 0xff);
  key_value_byte_new(&_bytes[5], 0x000000003fc0, 6, 0xff);
  key_value_byte_new(&_bytes[6], 0x00000000003f, -2, 0xfc);
  CALL(test_(&bit_offset, 0x7fffffffffff, 47, 7, 25, &_bytes));

  key_value_byte_new(&_bytes[0], 0xc000000000000000, 62, 0x03);
  key_value_byte_new(&_bytes[1], 0x3fc0000000000000, 54, 0xff);
  key_value_byte_new(&_bytes[2], 0x003fc00000000000, 46, 0xff);
  key_value_byte_new(&_bytes[3], 0x00003fc000000000, 38, 0xff);
  key_value_byte_new(&_bytes[4], 0x0000003fc0000000, 30, 0xff);
  key_value_byte_new(&_bytes[5], 0x000000003fc00000, 22, 0xff);
  key_value_byte_new(&_bytes[6], 0x00000000003fc000, 14, 0xff);
  key_value_byte_new(&_bytes[7], 0x0000000000003fc0, 6, 0xff);
  key_value_byte_new(&_bytes[8], 0x000000000000003f, -2, 0xfc);
  CALL(test_(&bit_offset, 0xffffffffffffffff, 64, 9, 31, &_bytes));

  delete(&_bytes, 9, key_value_byte);
}

FINISH


static void test_(ulong *bit_offset,
    ulong max_value,
    byte expected_bit_width,
    byte expected_num_bytes,
    ulong expected_first_offset,
    KeyValueByte ***expected_bytes) {
  byte u;
  ulong original_bit_offset;
  KeyValueField *_field = null;
  KeyValueByte *byt;
  KeyValueByte *ebyt;

  original_bit_offset = *bit_offset;
  key_value_field_new(&_field, max_value, bit_offset);
  EXPECT_ULEQ(max_value, _field->maxValue);
  EXPECT_ULEQ(expected_bit_width, _field->bitWidth);
  EXPECT_ULEQ(expected_num_bytes, _field->numBytes);
  EXPECT_ULEQ(expected_first_offset, _field->firstOffset);

  for (u = 0; u < expected_num_bytes; u++) {
    byt = _field->_bytes[u];
    ebyt = (*expected_bytes)[u];
    EXPECT_ULEQ(ebyt->valueMask, byt->valueMask);
    EXPECT_ULEQ(ebyt->shift, byt->shift);
    EXPECT_ULEQ(ebyt->readByteMask, byt->readByteMask);
  }

  EXPECT_ULEQ(original_bit_offset + expected_bit_width, *bit_offset);
  test_save_load(KeyValueField, key_value_field, _field);
  key_value_field_delete(&_field);
  delete(expected_bytes, 9, key_value_byte);
  new(expected_bytes, 9);
}
