#include "KeyValueNodeTestDeath.h"

START_DEATH

TEST(KeyValueNode, AddChunk) {
  ulong max = 1;
  KeyValueInfo *_info = null;
  KeyValueNode *_node = null;
  KeyValuePair *_pair = null;
  KeyValueArray *_array = null;

  key_value_node_new(&_node, null);
  set_info_new(&_info, 1, &max);
  key_value_array_new(&_array, _info, 3);
  key_value_array_finalize(_array);
  key_value_node_add_chunk(_node, &_array, 0, 0);
  key_value_array_new(&_array, _info, 5);
  EXPECT_DEATH(
      key_value_node_add_chunk(_node, &_array, 0, 0),
      "Attempt to add chunk to node that already has an array: index 0");
  EXPECT_DEATH(
      key_value_node_add_chunk(_node, &_array, 1, 1),
      "Attempt to add chunk to node that already has an array: index 1");
  key_value_array_delete(&_array);
  key_value_node_delete(&_node);

  key_value_node_new(&_node, null);
  key_value_array_new(&_array, _info, 3);
  key_value_pair_new(&_pair, _info);
  key_value_array_donate(_array, _pair);
  key_value_array_donate(_array, _pair);
  EXPECT_DEATH(
      key_value_node_add_chunk(_node, &_array, 0, 0),
      "Chunk is not finalized");
  key_value_pair_delete(&_pair, _info);
  key_value_array_delete(&_array);
  key_value_info_delete(&_info);
  key_value_node_delete(&_node);
}

FINISH_DEATH
