#include "NaiveKeyValueCollectionTest.h"

START

TEST(NaiveKeyValueCollection, NewPrint) {
  char *_e = null;
  char *_s = null;
  ulong max_keys[] = {0, 0};
  ulong max_values[] = {0, 0};
  KeyValueInfo *_info = null;
  KeyValuePair *_pair = null;
  NaiveKeyValueCollection *_ncollection = null;

  set_info_new(&_info, 1, max_keys);
  naive_key_value_collection_new(&_ncollection, _info, false);
  aprint(&_s, 0, naive_key_value_collection, _ncollection);
  EXPECT_STREQ(
      "[NaiveKeyValueCollection]\n. Number of values: 0\n"
      ". Number of single keys: 1\n[/NaiveKeyValueCollection]\n",
      _s);
  string_delete(&_s);
  naive_key_value_collection_delete(&_ncollection);
  key_value_info_delete(&_info);

  key_value_info_new(&_info, 1, max_keys, 1, max_values);
  naive_key_value_collection_new(&_ncollection, _info, false);
  key_value_pair_new(&_pair, _info);
  naive_key_value_collection_add_values(_ncollection, _pair);
  EXPECT_ULEQ(0, naive_key_value_collection_get_value(_ncollection, _pair, 0));
  aprint(&_s, 0, naive_key_value_collection, _ncollection);
  EXPECT_STREQ(
      "[NaiveKeyValueCollection]\n. Number of values: 1\n"
      ". Number of single keys: 1\n. [Contents]\n. . [Key = 0]\n. . . 0\n"
      ". . [/Key = 0]\n. [/Contents]\n[/NaiveKeyValueCollection]\n",
      _s);
  string_delete(&_s);
  key_value_pair_delete(&_pair, _info);
  naive_key_value_collection_delete(&_ncollection);
  key_value_info_delete(&_info);

  max_values[0] = 9;
  key_value_info_new(&_info, 1, max_keys, 1, max_values);
  naive_key_value_collection_new(&_ncollection, _info, false);
  key_value_pair_new(&_pair, _info);
  key_value_pair_set_value(_pair, _info, 0, 7);
  naive_key_value_collection_add_values(_ncollection, _pair);
  EXPECT_ULEQ(7, naive_key_value_collection_get_value(_ncollection, _pair, 0));
  aprint(&_s, 0, naive_key_value_collection, _ncollection);
  EXPECT_STREQ(
      "[NaiveKeyValueCollection]\n. Number of values: 1\n"
      ". Number of single keys: 1\n. [Contents]\n. . [Key = 0]\n. . . 7\n"
      ". . [/Key = 0]\n. [/Contents]\n[/NaiveKeyValueCollection]\n",
      _s);
  string_delete(&_s);
  key_value_pair_delete(&_pair, _info);
  naive_key_value_collection_delete(&_ncollection);
  key_value_info_delete(&_info);

  max_keys[0] = 2;
  max_keys[1] = 1;
  max_values[1] = 4;
  key_value_info_new(&_info, 2, max_keys, 2, max_values);
  naive_key_value_collection_new(&_ncollection, _info, false);
  key_value_pair_new(&_pair, _info);
  key_value_pair_set_key(_pair, _info, 0, 1);
  key_value_pair_set_key(_pair, _info, 1, 0);
  key_value_pair_set_value(_pair, _info, 0, 5);
  key_value_pair_set_value(_pair, _info, 1, 3);
  naive_key_value_collection_add_values(_ncollection, _pair);
  key_value_pair_set_key(_pair, _info, 0, 2);
  key_value_pair_set_key(_pair, _info, 1, 1);
  key_value_pair_set_value(_pair, _info, 0, 9);
  key_value_pair_set_value(_pair, _info, 1, 1);
  naive_key_value_collection_add_values(_ncollection, _pair);
  key_value_pair_set_key(_pair, _info, 0, 0);
  key_value_pair_set_key(_pair, _info, 1, 0);
  EXPECT_ULEQ(0, naive_key_value_collection_get_value(_ncollection, _pair, 0));
  EXPECT_ULEQ(0, naive_key_value_collection_get_value(_ncollection, _pair, 1));
  key_value_pair_set_key(_pair, _info, 0, 1);
  key_value_pair_set_key(_pair, _info, 1, 0);
  EXPECT_ULEQ(5, naive_key_value_collection_get_value(_ncollection, _pair, 0));
  EXPECT_ULEQ(3, naive_key_value_collection_get_value(_ncollection, _pair, 1));
  key_value_pair_set_key(_pair, _info, 0, 2);
  key_value_pair_set_key(_pair, _info, 1, 1);
  EXPECT_ULEQ(9, naive_key_value_collection_get_value(_ncollection, _pair, 0));
  EXPECT_ULEQ(1, naive_key_value_collection_get_value(_ncollection, _pair, 1));
  aprint(&_s, 0, naive_key_value_collection, _ncollection);
  string_new_f(
      &_e,
      "%s%s",
      "[NaiveKeyValueCollection]\n"
      ". Number of values: 2\n"
      ". Number of single keys: 6\n"
      ". [Contents]\n"
      ". . [Key 0 = 0]\n"
      ". . . [Key 1 = 0]\n"
      ". . . . [0] 0\n"
      ". . . . [1] 0\n"
      ". . . [/Key 1 = 0]\n"
      ". . . [Key 1 = 1]\n"
      ". . . . [0] 0\n"
      ". . . . [1] 0\n"
      ". . . [/Key 1 = 1]\n"
      ". . [/Key 0 = 0]\n"
      ". . [Key 0 = 1]\n"
      ". . . [Key 1 = 0]\n"
      ". . . . [0] 5\n"
      ". . . . [1] 3\n"
      ". . . [/Key 1 = 0]\n",
      ". . . [Key 1 = 1]\n"
      ". . . . [0] 0\n"
      ". . . . [1] 0\n"
      ". . . [/Key 1 = 1]\n"
      ". . [/Key 0 = 1]\n"
      ". . [Key 0 = 2]\n"
      ". . . [Key 1 = 0]\n"
      ". . . . [0] 0\n"
      ". . . . [1] 0\n"
      ". . . [/Key 1 = 0]\n"
      ". . . [Key 1 = 1]\n"
      ". . . . [0] 9\n"
      ". . . . [1] 1\n"
      ". . . [/Key 1 = 1]\n"
      ". . [/Key 0 = 2]\n"
      ". [/Contents]\n"
      "[/NaiveKeyValueCollection]\n",
      _s);
  EXPECT_STREQ(_e, _s);
  string_delete(&_s);
  string_delete(&_e);
  key_value_pair_delete(&_pair, _info);
  naive_key_value_collection_delete(&_ncollection);
  key_value_info_delete(&_info);
}

TEST(NaiveKeyValueCollection, SingleKey) {
  ulong max_keys[] = {3, 7};
  ulong max_values[] = {0, 0};
  KeyValueInfo *_info = null;
  KeyValuePair *_pair = null;
  NaiveKeyValueCollection *_ncollection = null;

  key_value_info_new(&_info, 2, max_keys, 2, max_values);
  naive_key_value_collection_new(&_ncollection, _info, false);
  key_value_pair_new(&_pair, _info);
  key_value_pair_set_key(_pair, _info, 0, 2);
  key_value_pair_set_key(_pair, _info, 1, 5);
  EXPECT_ULEQ(
      21,
      naive_key_value_collection_single_key_from_pair(_ncollection, _pair));
  naive_key_value_collection_pair_from_single_key(_ncollection, 23, _pair);
  EXPECT_ULEQ(2, key_value_pair_get_key(_pair, _info, 0));
  EXPECT_ULEQ(7, key_value_pair_get_key(_pair, _info, 1));
  key_value_pair_delete(&_pair, _info);
  naive_key_value_collection_delete(&_ncollection);
  key_value_info_delete(&_info);
}

FINISH
