#include "RandomWeightedTest.h"

static void print_(short *this, Printer *p);


START

TEST(RandomWeighted, Simple) {
  short s0;
  short s1;
  short s2;
  short s3;
  short s4;
  RandomWeightedNode *n;
  RandomWeighted *_ = null;

  random_weighted_new(&_, print_);
  EXPECT_TRUE(random_weighted_is_empty(_));
  random_weighted_delete(&_);

  random_weighted_new(&_, print_);

  s0 = 2409;
  n = random_weighted_add(_, &s0, 1.2);
  EXPECT_LEQ(2409, *(short *)n->object);
  EXPECT_LEQ(
      2409,
      *(short *)random_weighted_get_from_weight(_, 0, 0)->object);
  EXPECT_LEQ(
      2409,
      *(short *)random_weighted_get_from_weight(_, 0, 0.6)->object);
  EXPECT_LEQ(
      2409,
      *(short *)random_weighted_get_from_weight(_, 0, 1.2)->object);
  EXPECT_LEQ(
      2409,
      *(short *)random_weighted_get_from_weight(_, 2, 0)->object);
  EXPECT_LEQ(
      2409,
      *(short *)random_weighted_get_from_weight(_, 2, 1.3)->object);
  EXPECT_LEQ(
      2409,
      *(short *)random_weighted_get_from_weight(_, 2, 2.6)->object);

  s1 = -7;
  n = random_weighted_add(_, &s1, 0.4);
  EXPECT_LEQ(-7, *(short *)n->object);
  EXPECT_LEQ(
      -7,
      *(short *)random_weighted_get_from_weight(_, 0, 0)->object);
  EXPECT_LEQ(
      -7,
      *(short *)random_weighted_get_from_weight(_, 0, 0.3999)->object);
  EXPECT_LEQ(
      2409,
      *(short *)random_weighted_get_from_weight(_, 0, 0.401)->object);
  EXPECT_LEQ(
      2409,
      *(short *)random_weighted_get_from_weight(_, 0, 1.6)->object);
  EXPECT_LEQ(
      -7,
      *(short *)random_weighted_get_from_weight(_, 2, 0)->object);
  EXPECT_LEQ(
      -7,
      *(short *)random_weighted_get_from_weight(_, 2, 2.3999)->object);
  EXPECT_LEQ(
      2409,
      *(short *)random_weighted_get_from_weight(_, 2, 2.401)->object);
  EXPECT_LEQ(
      2409,
      *(short *)random_weighted_get_from_weight(_, 2, 5.6)->object);

  s2 = 1968;
  random_weighted_add(_, &s2, 0.3);
  EXPECT_LEQ(
      -7,
      *(short *)random_weighted_get_from_weight(_, 0, 0)->object);
  EXPECT_LEQ(
      -7,
      *(short *)random_weighted_get_from_weight(_, 0, 0.399)->object);
  EXPECT_LEQ(
      2409,
      *(short *)random_weighted_get_from_weight(_, 0, 0.401)->object);
  EXPECT_LEQ(
      2409,
      *(short *)random_weighted_get_from_weight(_, 0, 1.599)->object);
  EXPECT_LEQ(
      1968,
      *(short *)random_weighted_get_from_weight(_, 0, 1.601)->object);
  EXPECT_LEQ(
      1968,
      *(short *)random_weighted_get_from_weight(_, 0, 1.9)->object);
  EXPECT_LEQ(
      -7,
      *(short *)random_weighted_get_from_weight(_, 2, 0)->object);
  EXPECT_LEQ(
      -7,
      *(short *)random_weighted_get_from_weight(_, 2, 2.399)->object);
  EXPECT_LEQ(
      2409,
      *(short *)random_weighted_get_from_weight(_, 2, 2.401)->object);
  EXPECT_LEQ(
      2409,
      *(short *)random_weighted_get_from_weight(_, 2, 5.599)->object);
  EXPECT_LEQ(
      1968,
      *(short *)random_weighted_get_from_weight(_, 2, 5.601)->object);
  EXPECT_LEQ(
      1968,
      *(short *)random_weighted_get_from_weight(_, 2, 5.9)->object);

  s3 = 32767;
  random_weighted_add(_, &s3, 1.1);
  EXPECT_LEQ(
      32767,
      *(short *)random_weighted_get_from_weight(_, 0, 0)->object);
  EXPECT_LEQ(
      32767,
      *(short *)random_weighted_get_from_weight(_, 0, 1.09)->object);
  EXPECT_LEQ(
      -7,
      *(short *)random_weighted_get_from_weight(_, 0, 1.1001)->object);
  EXPECT_LEQ(
      -7,
      *(short *)random_weighted_get_from_weight(_, 0, 1.4999)->object);
  EXPECT_LEQ(
      2409,
      *(short *)random_weighted_get_from_weight(_, 0, 1.501)->object);
  EXPECT_LEQ(
      2409,
      *(short *)random_weighted_get_from_weight(_, 0, 2.699)->object);
  EXPECT_LEQ(
      1968,
      *(short *)random_weighted_get_from_weight(_, 0, 2.701)->object);
  EXPECT_LEQ(
      1968,
      *(short *)random_weighted_get_from_weight(_, 0, 3)->object);

  s4 = 1;
  random_weighted_add(_, &s4, 1);
  EXPECT_LEQ(
      32767,
      *(short *)random_weighted_get_from_weight(_, 0, 0)->object);
  EXPECT_LEQ(
      32767,
      *(short *)random_weighted_get_from_weight(_, 0, 1.09)->object);
  EXPECT_LEQ(
      -7,
      *(short *)random_weighted_get_from_weight(_, 0, 1.1001)->object);
  EXPECT_LEQ(
      -7,
      *(short *)random_weighted_get_from_weight(_, 0, 1.4999)->object);
  EXPECT_LEQ(
      1,
      *(short *)random_weighted_get_from_weight(_, 0, 1.5001)->object);
  EXPECT_LEQ(
      1,
      *(short *)random_weighted_get_from_weight(_, 0, 2.4999)->object);
  EXPECT_LEQ(
      2409,
      *(short *)random_weighted_get_from_weight(_, 0, 2.501)->object);
  EXPECT_LEQ(
      2409,
      *(short *)random_weighted_get_from_weight(_, 0, 3.699)->object);
  EXPECT_LEQ(
      1968,
      *(short *)random_weighted_get_from_weight(_, 0, 3.701)->object);
  EXPECT_LEQ(
      1968,
      *(short *)random_weighted_get_from_weight(_, 0, 4)->object);
  EXPECT_LEQ(
      32767,
      *(short *)random_weighted_get_from_weight(_, 2, 0)->object);
  EXPECT_LEQ(
      32767,
      *(short *)random_weighted_get_from_weight(_, 2, 3.09)->object);
  EXPECT_LEQ(
      -7,
      *(short *)random_weighted_get_from_weight(_, 2, 3.1001)->object);
  EXPECT_LEQ(
      -7,
      *(short *)random_weighted_get_from_weight(_, 2, 5.4999)->object);
  EXPECT_LEQ(
      1,
      *(short *)random_weighted_get_from_weight(_, 2, 5.5001)->object);
  EXPECT_LEQ(
      1,
      *(short *)random_weighted_get_from_weight(_, 2, 8.4999)->object);
  EXPECT_LEQ(
      2409,
      *(short *)random_weighted_get_from_weight(_, 2, 8.501)->object);
  EXPECT_LEQ(
      2409,
      *(short *)random_weighted_get_from_weight(_, 2, 11.699)->object);
  EXPECT_LEQ(
      1968,
      *(short *)random_weighted_get_from_weight(_, 2, 11.701)->object);
  EXPECT_LEQ(
      1968,
      *(short *)random_weighted_get_from_weight(_, 2, 12)->object);

  random_weighted_delete(&_);
}

TEST(RandomWeighted, Remove) {
  short s0;
  short s1;
  short s2;
  short s3;
  RandomWeightedNode *n;
  RandomWeightedNode *n0;
  RandomWeightedNode *n1;
  RandomWeightedNode *n2;
  RandomWeightedNode *n3;
  RandomWeighted *_ = null;

  random_weighted_new(&_, print_);

  s0 = 2409;
  random_weighted_add(_, &s0, 1.25);
  EXPECT_ULEQ(1, _->num);
  EXPECT_ULEQ(0, _->vetoedNum);
  EXPECT_ULEQ(0, _->removedNum);
  EXPECT_DEQ(1.25, _->weight);
  EXPECT_DEQ(0, _->vetoedWeight);
  EXPECT_DEQ(0, _->removedWeight);
  n = _->_root;
  EXPECT_DEQ(1.25, n->thisWeight);
  n0 = random_weighted_get_from_weight(_, 0, 0);
  EXPECT_LEQ(2409, *(short *)n0->object);

  s1 = -7;
  random_weighted_add(_, &s1, 0.5);
  EXPECT_ULEQ(2, _->num);
  EXPECT_ULEQ(0, _->vetoedNum);
  EXPECT_ULEQ(0, _->removedNum);
  EXPECT_DEQ(1.75, _->weight);
  EXPECT_DEQ(0, _->vetoedWeight);
  EXPECT_DEQ(0, _->removedWeight);
  n = _->_root;
  EXPECT_DEQ(1.25, n->thisWeight);
  EXPECT_DEQ(0.5, n->leftWeight);
  n = n->_left;
  EXPECT_DEQ(0.5, n->thisWeight);
  n1 = random_weighted_get_from_weight(_, 0, 0);
  EXPECT_LEQ(-7, *(short *)n1->object);

  random_weighted_remove(_, n0);
  EXPECT_ULEQ(2, _->num);
  EXPECT_ULEQ(0, _->vetoedNum);
  EXPECT_ULEQ(1, _->removedNum);
  EXPECT_DEQ(1.75, _->weight);
  EXPECT_DEQ(0, _->vetoedWeight);
  EXPECT_DEQ(1.25, _->removedWeight);
  n = _->_root;
  EXPECT_ULEQ(1, n->thisRemovedNum);
  EXPECT_DEQ(1.25, n->thisWeight);
  EXPECT_DEQ(1.25, n->thisRemovedWeight);
  EXPECT_DEQ(0.5, n->leftWeight);
  n = n->_left;
  EXPECT_DEQ(0.5, n->thisWeight);
  EXPECT_LEQ(-7, *(short *)random_weighted_get_from_weight(_, 0, 0)->object);
  EXPECT_LEQ(-7,
      *(short *)random_weighted_get_from_weight(_, 0, 0.25)->object);
  EXPECT_LEQ(-7, *(short *)random_weighted_get_from_weight(_, 0, 0.5)->object);
  EXPECT_LEQ(-7, *(short *)random_weighted_get_from_weight(_, 2, 0)->object);
  EXPECT_LEQ(-7,
      *(short *)random_weighted_get_from_weight(_, 2, 1.25)->object);
  EXPECT_LEQ(-7, *(short *)random_weighted_get_from_weight(_, 2, 2.5)->object);

  s2 = 1968;
  random_weighted_add(_, &s2, 1.5);
  EXPECT_ULEQ(3, _->num);
  EXPECT_ULEQ(0, _->vetoedNum);
  EXPECT_ULEQ(1, _->removedNum);
  EXPECT_DEQ(3.25, _->weight);
  EXPECT_DEQ(0, _->vetoedWeight);
  EXPECT_DEQ(1.25, _->removedWeight);
  n = _->_root;
  EXPECT_DEQ(1.25, n->thisWeight);
  EXPECT_DEQ(1.25, n->thisRemovedWeight);
  EXPECT_DEQ(0.5, n->leftWeight);
  n = n->_left;
  EXPECT_DEQ(0.5, n->thisWeight);
  n = n->parent;
  EXPECT_DEQ(1.5, n->rightWeight);
  n = n->_right;
  EXPECT_DEQ(1.5, n->thisWeight);
  n2 = random_weighted_get_from_weight(_, 0, 1);
  EXPECT_LEQ(1968, *(short *)n2->object);
  EXPECT_LEQ(-7, *(short *)random_weighted_get_from_weight(_, 0, 0)->object);
  EXPECT_LEQ(-7,
      *(short *)random_weighted_get_from_weight(_, 0, 0.49)->object);
  EXPECT_LEQ(
      1968,
      *(short *)random_weighted_get_from_weight(_, 0, 0.5)->object);
  EXPECT_LEQ(
      1968,
      *(short *)random_weighted_get_from_weight(_, 0, 2)->object);
  EXPECT_LEQ(-7, *(short *)random_weighted_get_from_weight(_, 2, 0)->object);
  EXPECT_LEQ(-7,
      *(short *)random_weighted_get_from_weight(_, 2, 2.49)->object);
  EXPECT_LEQ(
      1968,
      *(short *)random_weighted_get_from_weight(_, 2, 2.5)->object);
  EXPECT_LEQ(
      1968,
      *(short *)random_weighted_get_from_weight(_, 2, 4)->object);

  random_weighted_remove(_, n2);
  EXPECT_ULEQ(3, _->num);
  EXPECT_ULEQ(0, _->vetoedNum);
  EXPECT_ULEQ(2, _->removedNum);
  EXPECT_DEQ(3.25, _->weight);
  EXPECT_DEQ(0, _->vetoedWeight);
  EXPECT_DEQ(2.75, _->removedWeight);
  n = _->_root;
  EXPECT_ULEQ(1, n->thisRemovedNum);
  EXPECT_DEQ(1.25, n->thisWeight);
  EXPECT_DEQ(1.25, n->thisRemovedWeight);
  EXPECT_DEQ(0.5, n->leftWeight);
  n = n->_left;
  EXPECT_DEQ(0.5, n->thisWeight);
  n = n->parent;
  EXPECT_ULEQ(1, n->rightRemovedNum);
  EXPECT_DEQ(1.5, n->rightWeight);
  EXPECT_DEQ(1.5, n->rightRemovedWeight);
  n = n->_right;
  EXPECT_ULEQ(1, n->thisRemovedNum);
  EXPECT_DEQ(1.5, n->thisWeight);
  EXPECT_DEQ(1.5, n->thisRemovedWeight);
  EXPECT_LEQ(-7, *(short *)random_weighted_get_from_weight(_, 0, 0)->object);
  EXPECT_LEQ(-7,
      *(short *)random_weighted_get_from_weight(_, 0, 0.25)->object);
  EXPECT_LEQ(-7, *(short *)random_weighted_get_from_weight(_, 0, 0.5)->object);
  EXPECT_LEQ(-7, *(short *)random_weighted_get_from_weight(_, 2, 0)->object);
  EXPECT_LEQ(-7,
      *(short *)random_weighted_get_from_weight(_, 2, 1.25)->object);
  EXPECT_LEQ(-7, *(short *)random_weighted_get_from_weight(_, 2, 2.5)->object);

  s3 = -1966;
  random_weighted_add(_, &s3, 1.75);
  EXPECT_ULEQ(4, _->num);
  EXPECT_ULEQ(0, _->vetoedNum);
  EXPECT_ULEQ(2, _->removedNum);
  EXPECT_DEQ(5, _->weight);
  EXPECT_DEQ(0, _->vetoedWeight);
  EXPECT_DEQ(2.75, _->removedWeight);
  n = _->_root;
  EXPECT_ULEQ(1, n->thisRemovedNum);
  EXPECT_DEQ(1.25, n->thisWeight);
  EXPECT_DEQ(1.25, n->thisRemovedWeight);
  EXPECT_DEQ(2.25, n->leftWeight);
  n = n->_left;
  EXPECT_DEQ(0.5, n->thisWeight);
  n = n->_left;
  EXPECT_DEQ(1.75, n->thisWeight);
  n = n->parent->parent;
  EXPECT_ULEQ(1, n->rightRemovedNum);
  EXPECT_DEQ(1.5, n->rightWeight);
  EXPECT_DEQ(1.5, n->rightRemovedWeight);
  n = n->_right;
  EXPECT_ULEQ(1, n->thisRemovedNum);
  EXPECT_DEQ(1.5, n->thisWeight);
  EXPECT_DEQ(1.5, n->thisRemovedWeight);
  EXPECT_LEQ(
      -1966,
      *(short *)random_weighted_get_from_weight(_, 0, 0)->object);
  EXPECT_LEQ(
      -1966,
      *(short *)random_weighted_get_from_weight(_, 0, 1.7499)->object);
  EXPECT_LEQ(
      -7,
      *(short *)random_weighted_get_from_weight(_, 0, 1.7501)->object);
  EXPECT_LEQ(
      -7,
      *(short *)random_weighted_get_from_weight(_, 0, 2.25)->object);
  EXPECT_LEQ(
      -1966,
      *(short *)random_weighted_get_from_weight(_, 2, 0)->object);
  EXPECT_LEQ(
      -1966,
      *(short *)random_weighted_get_from_weight(_, 2, 3.7499)->object);
  EXPECT_LEQ(
      -7,
      *(short *)random_weighted_get_from_weight(_, 2, 3.7501)->object);
  EXPECT_LEQ(
      -7,
      *(short *)random_weighted_get_from_weight(_, 2, 4.25)->object);

  random_weighted_remove(_, n1);
  EXPECT_ULEQ(4, _->num);
  EXPECT_ULEQ(0, _->vetoedNum);
  EXPECT_ULEQ(3, _->removedNum);
  EXPECT_DEQ(5, _->weight);
  EXPECT_DEQ(0, _->vetoedWeight);
  EXPECT_DEQ(3.25, _->removedWeight);
  n = _->_root;
  EXPECT_ULEQ(1, n->thisRemovedNum);
  EXPECT_DEQ(1.25, n->thisWeight);
  EXPECT_DEQ(1.25, n->thisRemovedWeight);
  EXPECT_DEQ(2.25, n->leftWeight);
  n = n->_left;
  EXPECT_ULEQ(1, n->thisRemovedNum);
  EXPECT_DEQ(0.5, n->thisWeight);
  EXPECT_DEQ(0.5, n->thisRemovedWeight);
  n = n->_left;
  EXPECT_DEQ(1.75, n->thisWeight);
  n = n->parent->parent;
  EXPECT_ULEQ(1, n->rightRemovedNum);
  EXPECT_DEQ(1.5, n->rightWeight);
  EXPECT_DEQ(1.5, n->rightRemovedWeight);
  n = n->_right;
  EXPECT_ULEQ(1, n->thisRemovedNum);
  EXPECT_DEQ(1.5, n->thisWeight);
  EXPECT_DEQ(1.5, n->thisRemovedWeight);
  EXPECT_DEQ(0, n->rightWeight);
  EXPECT_LEQ(
      -1966,
      *(short *)random_weighted_get_from_weight(_, 2, 1.75)->object);

  n3 = random_weighted_get_from_weight(_, 0, 1);
  random_weighted_remove(_, n3);
  EXPECT_ULEQ(4, _->num);
  EXPECT_ULEQ(0, _->vetoedNum);
  EXPECT_ULEQ(4, _->removedNum);
  EXPECT_DEQ(5, _->weight);
  EXPECT_DEQ(0, _->vetoedWeight);
  EXPECT_DEQ(5, _->removedWeight);
  n = _->_root;
  EXPECT_ULEQ(1, n->thisRemovedNum);
  EXPECT_DEQ(1.25, n->thisWeight);
  EXPECT_DEQ(1.25, n->thisRemovedWeight);
  EXPECT_ULEQ(2, n->leftNum);
  EXPECT_ULEQ(2, n->leftRemovedNum);
  EXPECT_DEQ(2.25, n->leftWeight);
  EXPECT_DEQ(2.25, n->leftRemovedWeight);
  n = n->_left;
  EXPECT_ULEQ(1, n->thisRemovedNum);
  EXPECT_DEQ(0.5, n->thisWeight);
  EXPECT_DEQ(0.5, n->thisRemovedWeight);
  n = n->_left;
  EXPECT_ULEQ(1, n->thisRemovedNum);
  EXPECT_DEQ(1.75, n->thisWeight);
  EXPECT_DEQ(1.75, n->thisRemovedWeight);
  n = n->parent->parent;
  EXPECT_ULEQ(1, n->rightRemovedNum);
  EXPECT_DEQ(1.5, n->rightWeight);
  EXPECT_DEQ(1.5, n->rightRemovedWeight);
  n = n->_right;
  EXPECT_ULEQ(1, n->thisRemovedNum);
  EXPECT_DEQ(1.5, n->thisWeight);
  EXPECT_DEQ(1.5, n->thisRemovedWeight);
  EXPECT_DEQ(0, n->rightWeight);

  random_weighted_delete(&_);
}

TEST(RandomWeighted, VetoUnveto) {
  short s0;
  short s1;
  short s2;
  short s3;
  RandomWeightedNode *n;
  RandomWeightedNode *n0;
  RandomWeightedNode *n1;
  RandomWeightedNode *n2;
  RandomWeightedNode *n3;
  RandomWeighted *_ = null;

  random_weighted_new(&_, print_);

  s0 = 2409;
  random_weighted_add(_, &s0, 1.25);
  EXPECT_ULEQ(1, _->num);
  EXPECT_ULEQ(0, _->vetoedNum);
  EXPECT_ULEQ(0, _->removedNum);
  EXPECT_DEQ(1.25, _->weight);
  EXPECT_DEQ(0, _->vetoedWeight);
  n = _->_root;
  EXPECT_DEQ(1.25, n->thisWeight);
  EXPECT_DEQ(0, n->thisVetoedWeight);
  n0 = random_weighted_get_from_weight(_, 0, 0);
  EXPECT_LEQ(2409, *(short *)n0->object);

  s1 = -7;
  random_weighted_add(_, &s1, 0.5);
  EXPECT_ULEQ(2, _->num);
  EXPECT_ULEQ(0, _->vetoedNum);
  EXPECT_DEQ(1.75, _->weight);
  EXPECT_DEQ(0, _->vetoedWeight);
  n = _->_root;
  EXPECT_DEQ(1.25, n->thisWeight);
  EXPECT_DEQ(0, n->thisVetoedWeight);
  EXPECT_DEQ(0.5, n->leftWeight);
  EXPECT_DEQ(0, n->leftVetoedWeight);
  n = n->_left;
  EXPECT_DEQ(0.5, n->thisWeight);
  EXPECT_DEQ(0, n->thisVetoedWeight);
  n1 = random_weighted_get_from_weight(_, 0, 0);
  EXPECT_LEQ(-7, *(short *)n1->object);

  random_weighted_veto(_, n0);
  EXPECT_ULEQ(2, _->num);
  EXPECT_ULEQ(1, _->vetoedNum);
  EXPECT_DEQ(1.75, _->weight);
  EXPECT_DEQ(1.25, _->vetoedWeight);
  n = _->_root;
  EXPECT_DEQ(1.25, n->thisWeight);
  EXPECT_DEQ(1.25, n->thisVetoedWeight);
  EXPECT_DEQ(0.5, n->leftWeight);
  EXPECT_DEQ(0, n->leftVetoedWeight);
  n = n->_left;
  EXPECT_DEQ(0.5, n->thisWeight);
  EXPECT_DEQ(0, n->thisVetoedWeight);
  EXPECT_LEQ(
      -7,
      *(short *)random_weighted_get_from_weight(_, 0, 0)->object);
  EXPECT_LEQ(
      -7,
      *(short *)random_weighted_get_from_weight(_, 0, 0.5)->object);
  EXPECT_LEQ(
      -7,
      *(short *)random_weighted_get_from_weight(_, 2, 0)->object);
  EXPECT_LEQ(
      -7,
      *(short *)random_weighted_get_from_weight(_, 2, 2.5)->object);

  s2 = 1968;
  random_weighted_add(_, &s2, 1.5);
  EXPECT_ULEQ(3, _->num);
  EXPECT_ULEQ(1, _->vetoedNum);
  EXPECT_DEQ(3.25, _->weight);
  EXPECT_DEQ(1.25, _->vetoedWeight);
  n = _->_root;
  EXPECT_DEQ(1.25, n->thisWeight);
  EXPECT_DEQ(1.25, n->thisVetoedWeight);
  EXPECT_DEQ(0.5, n->leftWeight);
  EXPECT_DEQ(0, n->leftVetoedWeight);
  n = n->_left;
  EXPECT_DEQ(0.5, n->thisWeight);
  EXPECT_DEQ(0, n->thisVetoedWeight);
  n = n->parent;
  EXPECT_DEQ(1.5, n->rightWeight);
  EXPECT_DEQ(0, n->rightVetoedWeight);
  n = n->_right;
  EXPECT_DEQ(1.5, n->thisWeight);
  EXPECT_DEQ(0, n->thisVetoedWeight);
  n2 = random_weighted_get_from_weight(_, 0, 1);
  EXPECT_LEQ(1968, *(short *)n2->object);

  random_weighted_veto(_, n2);
  EXPECT_ULEQ(3, _->num);
  EXPECT_ULEQ(2, _->vetoedNum);
  EXPECT_DEQ(3.25, _->weight);
  EXPECT_DEQ(2.75, _->vetoedWeight);
  n = _->_root;
  EXPECT_DEQ(1.25, n->thisWeight);
  EXPECT_DEQ(1.25, n->thisVetoedWeight);
  EXPECT_DEQ(0.5, n->leftWeight);
  EXPECT_DEQ(0, n->leftVetoedWeight);
  n = n->_left;
  EXPECT_DEQ(0.5, n->thisWeight);
  EXPECT_DEQ(0, n->thisVetoedWeight);
  n = n->parent;
  EXPECT_DEQ(1.5, n->rightWeight);
  EXPECT_DEQ(1.5, n->rightVetoedWeight);
  n = n->_right;
  EXPECT_DEQ(1.5, n->thisWeight);
  EXPECT_DEQ(1.5, n->thisVetoedWeight);
  EXPECT_LEQ(
      -7,
      *(short *)random_weighted_get_from_weight(_, 0, 0)->object);
  EXPECT_LEQ(
      -7,
      *(short *)random_weighted_get_from_weight(_, 0, 0.5)->object);
  EXPECT_LEQ(
      -7,
      *(short *)random_weighted_get_from_weight(_, 2, 0)->object);
  EXPECT_LEQ(
      -7,
      *(short *)random_weighted_get_from_weight(_, 2, 2.5)->object);

  s3 = -1966;
  random_weighted_add(_, &s3, 1.75);
  EXPECT_ULEQ(4, _->num);
  EXPECT_ULEQ(2, _->vetoedNum);
  EXPECT_DEQ(5, _->weight);
  EXPECT_DEQ(2.75, _->vetoedWeight);
  n = _->_root;
  EXPECT_DEQ(1.25, n->thisWeight);
  EXPECT_DEQ(1.25, n->thisVetoedWeight);
  EXPECT_DEQ(2.25, n->leftWeight);
  EXPECT_DEQ(0, n->leftVetoedWeight);
  n = n->_left;
  EXPECT_DEQ(0.5, n->thisWeight);
  EXPECT_DEQ(0, n->thisVetoedWeight);
  EXPECT_DEQ(1.75, n->leftWeight);
  EXPECT_DEQ(0, n->leftVetoedWeight);
  n = n->_left;
  EXPECT_DEQ(1.75, n->thisWeight);
  EXPECT_DEQ(0, n->thisVetoedWeight);
  n = n->parent->parent;
  EXPECT_DEQ(1.5, n->rightWeight);
  EXPECT_DEQ(1.5, n->rightVetoedWeight);
  n = n->_right;
  EXPECT_DEQ(1.5, n->thisWeight);
  EXPECT_DEQ(1.5, n->thisVetoedWeight);

  random_weighted_veto(_, n1);
  EXPECT_ULEQ(4, _->num);
  EXPECT_ULEQ(3, _->vetoedNum);
  EXPECT_DEQ(5, _->weight);
  EXPECT_DEQ(3.25, _->vetoedWeight);
  n = _->_root;
  EXPECT_DEQ(1.25, n->thisWeight);
  EXPECT_DEQ(1.25, n->thisVetoedWeight);
  EXPECT_DEQ(2.25, n->leftWeight);
  EXPECT_DEQ(0.5, n->leftVetoedWeight);
  n = n->_left;
  EXPECT_DEQ(0.5, n->thisWeight);
  EXPECT_DEQ(0.5, n->thisVetoedWeight);
  EXPECT_DEQ(1.75, n->leftWeight);
  EXPECT_DEQ(0, n->leftVetoedWeight);
  n = n->_left;
  EXPECT_DEQ(1.75, n->thisWeight);
  EXPECT_DEQ(0, n->thisVetoedWeight);
  n = n->parent->parent;
  EXPECT_DEQ(1.5, n->rightWeight);
  EXPECT_DEQ(1.5, n->rightVetoedWeight);
  n = n->_right;
  EXPECT_DEQ(1.5, n->thisWeight);
  EXPECT_DEQ(1.5, n->thisVetoedWeight);
  EXPECT_LEQ(
      -1966,
      *(short *)random_weighted_get_from_weight(_, 0, 0)->object);
  EXPECT_LEQ(
      -1966,
      *(short *)random_weighted_get_from_weight(_, 0, 1.75)->object);
  EXPECT_LEQ(
      -1966,
      *(short *)random_weighted_get_from_weight(_, 2, 0)->object);
  EXPECT_LEQ(
      -1966,
      *(short *)random_weighted_get_from_weight(_, 2, 3.75)->object);

  n3 = random_weighted_get_from_weight(_, 0, 1);
  random_weighted_veto(_, n3);
  EXPECT_ULEQ(4, _->num);
  EXPECT_ULEQ(4, _->vetoedNum);
  EXPECT_DEQ(5, _->weight);
  EXPECT_DEQ(5, _->vetoedWeight);
  n = _->_root;
  EXPECT_DEQ(1.25, n->thisWeight);
  EXPECT_DEQ(1.25, n->thisVetoedWeight);
  EXPECT_DEQ(2.25, n->leftWeight);
  EXPECT_DEQ(2.25, n->leftVetoedWeight);
  n = n->_left;
  EXPECT_DEQ(0.5, n->thisWeight);
  EXPECT_DEQ(0.5, n->thisVetoedWeight);
  EXPECT_DEQ(1.75, n->leftWeight);
  EXPECT_DEQ(1.75, n->leftVetoedWeight);
  n = n->_left;
  EXPECT_DEQ(1.75, n->thisWeight);
  EXPECT_DEQ(1.75, n->thisVetoedWeight);
  n = n->parent->parent;
  EXPECT_DEQ(1.5, n->rightWeight);
  EXPECT_DEQ(1.5, n->rightVetoedWeight);
  n = n->_right;
  EXPECT_DEQ(1.5, n->thisWeight);
  EXPECT_DEQ(1.5, n->thisVetoedWeight);

  random_weighted_unveto(_, n3);
  EXPECT_ULEQ(4, _->num);
  EXPECT_ULEQ(3, _->vetoedNum);
  EXPECT_DEQ(5, _->weight);
  EXPECT_DEQ(3.25, _->vetoedWeight);
  n = _->_root;
  EXPECT_DEQ(1.25, n->thisWeight);
  EXPECT_DEQ(1.25, n->thisVetoedWeight);
  EXPECT_DEQ(2.25, n->leftWeight);
  EXPECT_DEQ(0.5, n->leftVetoedWeight);
  n = n->_left;
  EXPECT_DEQ(0.5, n->thisWeight);
  EXPECT_DEQ(0.5, n->thisVetoedWeight);
  EXPECT_DEQ(1.75, n->leftWeight);
  EXPECT_DEQ(0, n->leftVetoedWeight);
  n = n->_left;
  EXPECT_DEQ(1.75, n->thisWeight);
  EXPECT_DEQ(0, n->thisVetoedWeight);
  n = n->parent->parent;
  EXPECT_DEQ(1.5, n->rightWeight);
  EXPECT_DEQ(1.5, n->rightVetoedWeight);
  n = n->_right;
  EXPECT_DEQ(1.5, n->thisWeight);
  EXPECT_DEQ(1.5, n->thisVetoedWeight);
  EXPECT_LEQ(
      -1966,
      *(short *)random_weighted_get_from_weight(_, 0, 0)->object);
  EXPECT_LEQ(
      -1966,
      *(short *)random_weighted_get_from_weight(_, 0, 1.75)->object);
  EXPECT_LEQ(
      -1966,
      *(short *)random_weighted_get_from_weight(_, 2, 0)->object);
  EXPECT_LEQ(
      -1966,
      *(short *)random_weighted_get_from_weight(_, 2, 3.75)->object);

  random_weighted_delete(&_);
}

TEST(RandomWeighted, Zero) {
  short s0;
  short s1;
  short s2;
  RandomWeighted *_ = null;

  random_weighted_new(&_, print_);

  s0 = 2409;
  random_weighted_add(_, &s0, 1.25);
  s1 = -7;
  random_weighted_add(_, &s1, 0.5);
  s2 = 1968;
  random_weighted_add(_, &s2, 1.5);

  random_weighted_zero(_, _->_root->_left);
  EXPECT_DEQ(2.75, _->weight);
  EXPECT_DEQ(0, _->_root->_left->thisWeight);
  EXPECT_DEQ(0, _->_root->leftWeight);

  random_weighted_zero(_, _->_root->_left);
  EXPECT_DEQ(2.75, _->weight);
  EXPECT_DEQ(0, _->_root->_left->thisWeight);
  EXPECT_DEQ(0, _->_root->leftWeight);

  random_weighted_zero(_, _->_root->_right);
  EXPECT_DEQ(1.25, _->weight);
  EXPECT_DEQ(0, _->_root->_right->thisWeight);
  EXPECT_DEQ(0, _->_root->rightWeight);

  random_weighted_zero(_, _->_root);
  EXPECT_DEQ(0, _->weight);
  EXPECT_DEQ(0, _->_root->thisWeight);

  random_weighted_delete(&_);
}

FINISH


static void print_(short *this, Printer *p) {
  rprint(p, "%d", *this);
}
