#include "RankerTest.h"

START

TEST(Ranker, Simple) {
  Ranker *_ = null;

  ranker_new(&_);
  ranker_add(_, 3.25, 2);
  ranker_add(_, -1, 3);
  ranker_add(_, -7.5, 1);
  ranker_add(_, 124, 4);
  ranker_finalize(_);

  EXPECT_LEQ(-10, ranker_crank_from_value(_, -14));
  EXPECT_LEQ(-10, ranker_crank_from_value(_, -7.5001));
  EXPECT_LEQ(-9, ranker_crank_from_value(_, -7.5));
  EXPECT_LEQ(-8, ranker_crank_from_value(_, -7.4999));
  EXPECT_LEQ(-8, ranker_crank_from_value(_, -1.0001));
  EXPECT_LEQ(-5, ranker_crank_from_value(_, -1));
  EXPECT_LEQ(-2, ranker_crank_from_value(_, -0.9999));
  EXPECT_LEQ(-2, ranker_crank_from_value(_, 3.2499));
  EXPECT_LEQ(+0, ranker_crank_from_value(_, 3.25));
  EXPECT_LEQ(+2, ranker_crank_from_value(_, 3.2501));
  EXPECT_LEQ(+2, ranker_crank_from_value(_, 123.9999));
  EXPECT_LEQ(+6, ranker_crank_from_value(_, 124));
  EXPECT_LEQ(+10, ranker_crank_from_value(_, 124.0001));

  EXPECT_DEQ(-7.5, ranker_value_from_crank(_, -14));
  EXPECT_DEQ(-7.5, ranker_value_from_crank(_, -10.0001));
  EXPECT_DEQ(-7.5, ranker_value_from_crank(_, -10));
  EXPECT_DEQ(-7.5, ranker_value_from_crank(_, -9.9999));
  EXPECT_DEQ(-7.5, ranker_value_from_crank(_, -9));
  EXPECT_DEQ(-7.5, ranker_value_from_crank(_, -8.0001));
  EXPECT_DEQ(-4.25, ranker_value_from_crank(_, -8));
  EXPECT_DEQ(-1, ranker_value_from_crank(_, -7.9999));
  EXPECT_DEQ(-1, ranker_value_from_crank(_, -5.0001));
  EXPECT_DEQ(-1, ranker_value_from_crank(_, -5));
  EXPECT_DEQ(-1, ranker_value_from_crank(_, -4.9999));
  EXPECT_DEQ(-1, ranker_value_from_crank(_, -2.0001));
  EXPECT_DEQ(1.125, ranker_value_from_crank(_, -2));
  EXPECT_DEQ(3.25, ranker_value_from_crank(_, -1.9999));
  EXPECT_DEQ(3.25, ranker_value_from_crank(_, 0));
  EXPECT_DEQ(3.25, ranker_value_from_crank(_, +1.9999));
  EXPECT_DEQ(63.625, ranker_value_from_crank(_, +2));
  EXPECT_DEQ(124, ranker_value_from_crank(_, +2.0001));
  EXPECT_DEQ(124, ranker_value_from_crank(_, +5.9999));
  EXPECT_DEQ(124, ranker_value_from_crank(_, +6));
  EXPECT_DEQ(124, ranker_value_from_crank(_, +6.0001));
  EXPECT_DEQ(124, ranker_value_from_crank(_, +9.9999));
  EXPECT_DEQ(124, ranker_value_from_crank(_, +10));
  EXPECT_DEQ(124, ranker_value_from_crank(_, +10.0001));
  EXPECT_DEQ(124, ranker_value_from_crank(_, +123));

  test_save_load(Ranker, ranker, _);

  ranker_delete(&_);
}

FINISH
