#include "RankerTestDeath.h"

START_DEATH

TEST(Ranker, Simple) {
  Ranker *_ = null;

  ranker_new(&_);
  EXPECT_DEATH(ranker_add(_, 6.5, 0), "Frequency cannot be zero");
  EXPECT_DEATH(
      ranker_add(_, DBL_NAN, 1),
      "Cannot add the infinite or NaN value nan");
  EXPECT_DEATH(
      ranker_add(_, DBL_POSINF, 1),
      "Cannot add the infinite or NaN value inf");
  EXPECT_DEATH(
      ranker_add(_, DBL_NEGINF, 1),
      "Cannot add the infinite or NaN value -inf");
  EXPECT_DEATH(ranker_finalize(_), "Nothing added before finalizing");
  ranker_delete(&_);


  ranker_new(&_);
  EXPECT_DEATH(
      ranker_crank_from_value(_, 0),
      "Cannot get crank from value before being finalized");
  EXPECT_DEATH(
      ranker_value_from_crank(_, 0),
      "Cannot get value from crank before being finalized");
  ranker_delete(&_);
}

FINISH_DEATH
