#include "SparseKeyFrequencyTest.h"

START

TEST(SparseKeyFrequencyInfo, New) {
  ulong max_keys[] = {6, 24};
  KeyValueInfo *_info = null;

  sparse_key_frequency_info_new(&_info, 2, max_keys, 7);
  EXPECT_ULEQ(2, _info->numKeys);
  EXPECT_ULEQ(1, _info->numValues);
  EXPECT_ULEQ(3, _info->numFields);
  EXPECT_ULEQ(6, _info->maxKeys[0]);
  EXPECT_ULEQ(24, _info->maxKeys[1]);
  EXPECT_ULEQ(7, _info->maxValues[0]);
  key_value_info_delete(&_info);
}

TEST(SparseKeyFrequencyPair, SetGetFrequency) {
  ulong max_key = 7;
  KeyValueInfo *_info = null;
  KeyValuePair *_pair = null;

  sparse_key_frequency_info_new(&_info, 1, &max_key, 7);
  key_value_pair_new(&_pair, _info);
  sparse_key_frequency_pair_set_frequency(_pair, _info, 5);
  EXPECT_ULEQ(5, sparse_key_frequency_pair_get_frequency(_pair, _info));
  key_value_pair_delete(&_pair, _info);
  key_value_info_delete(&_info);
}

FINISH
